#ifdef MOUHDRS
#define MOUEXTN /* */
#else
#define MOUEXTN extern
#endif

/*----------------------------------------------------------------------------*/
/*  Include OS2      definition header file                                   */
/*----------------------------------------------------------------------------*/
#ifdef OS2
#ifndef OS2_INCLUDED
#define INCL_BASE
#include <os2.h>
#endif
#endif

/* mouse.c parameters */

#ifndef OS2
typedef struct _MOUEVENTINFO /* mouev */
{
    unsigned int fs;
    unsigned long  time;
    unsigned int row;
    unsigned int col;
}MOUEVENTINFO;

#define MOUSE_MOTION                0x0001
#define MOUSE_MOTION_WITH_BN1_DOWN  0x0002
#define MOUSE_BN1_DOWN              0x0004
#define MOUSE_MOTION_WITH_BN2_DOWN  0x0008
#define MOUSE_BN2_DOWN              0x0010
#define MOUSE_MOTION_WITH_BN3_DOWN  0x0020
#define MOUSE_BN3_DOWN              0x0040
#endif

#ifdef OS2
MOUEXTN PTRLOC MOUSE_POS;                  /* MOUSETPTRPOS struct definition */
#endif

#ifdef MOUHDRS
int MOUSE_HANDLE = 0xff;                   /* Mouse cursor device handle */
#else
extern int MOUSE_HANDLE;                   /* Mouse cursor device handle */
#endif

MOUEXTN int MOUSE_HIDE_COUNT;              /* Mouse hide count */
MOUEXTN unsigned int MOUSE_EVENT_MASK;     /* Mouse toggle button 3 off */
MOUEXTN unsigned int MOUSE_READ_TYPE;      /* Mouse read type 0=NOWAIT 1=WAIT */
MOUEXTN int MOUSE_RB;                      /* Mouse starting row */
MOUEXTN int MOUSE_RE;                      /* Mouse ending row */
MOUEXTN int MOUSE_CB;                      /* Mouse starting column */
MOUEXTN int MOUSE_CE;                      /* Mouse ending column */
MOUEXTN char *MOUSE_STATE_PTR;             /* Mouse save status buffer */
MOUEXTN int MOUSE_SAVE_FS;                 /* Mouse release flag */
MOUEXTN int MOUSE_CLICK_SWT;               /* Mouse click switch */
MOUEXTN int MOUSE_DOUBLE_CLICK;            /* Mouse double click */
MOUEXTN int MOUSE_DOUBLE_ROW;              /* Mouse save row */
MOUEXTN long MOUSE_DOUBLE_TIME;            /* Mouse save time */
MOUEXTN MOUEVENTINFO MOUSE_EVENT_BUFFER;   /* Mouse event buffer */

/* double click tick threshold */
#ifdef OS2
#define MOUSE_DBL_CLICK_THRESHOLD       750L   /* milliseconds  */
#else
#define MOUSE_DBL_CLICK_THRESHOLD        16L   /* 18 per second */
#endif

/* function prototypes */

int     _fastcall  mouse_open(int, int, unsigned int, int, int);
void    _fastcall  mouse_position(int, int);
int     _fastcall  mouse_read(int);
void    _fastcall  mouse_close(void);
int     _fastcall  mouse_release(int);
int     _fastcall  mouse_wait_ki(void);
int     _fastcall  mouse_show(void);
int     _fastcall  mouse_hide(void);
int     _fastcall  mouse_ki_chk(void);
void    _fastcall  mouse_coordinates(int, int, int, int);
void    _fastcall  mouse_restore_buffer(void);
void    _fastcall  mouse_save_buffer(void);
int     _fastcall  mouse_wait_ki(void);
